## mingw-w64-llvm-19.1.7-1.src.tar.zst

=== docs/requirements.txt ===
sphinx==7.2.6
docutils==0.20.1
sphinx-markdown-tables==0.0.17
recommonmark==0.7.1
sphinx-automodapi==0.17.0
sphinx-bootstrap-theme==0.8.1
sphinxcontrib-applehelp==1.0.8
furo==2024.1.29
myst-parser==2.0.0
